#!/bin/bash

affichage=0
#taille=100

echo -e "iTest\ttaille\ttemps\tmem\talgo\ttypeTableau"

for iTest in `seq 1 10`
do
  taille=$(( `od -An -N4 -tu < /dev/urandom` % 100000))

  for algo in 'i' 'r' 'f'
  do

    for typeTableau in 'a' 'r' 'i' 'c'
      do
      res=`( /usr/bin/time -f "%U\t%M" ./main $algo $taille $typeTableau $affichage > /dev/null ) 2>&1`
      echo -e "$iTest\t$taille\t$res\t$algo\t$typeTableau"
    done
  done
done
