#include <stdio.h>
#include <stdlib.h>
#include "utils.h"

void affichertab(long *T, int s)
{
  printf("[ ");
  for (int i = 0; i < s - 1; i++)
  {
    printf("%d , ", T[i]);
  }
  printf("%d ]\n", T[s - 1]);
}

void genTab(long *T, long taille, char type, long MAX)
{

  switch (type)
  {
  case 'a':
    //Tableau Aleatoire
    for (long i = 0; i < taille; ++i)
    {
      T[i] = rand() % MAX;
    }
    break;

  case 'r':
    //Tableau Rangé
    for (long i = 0; i < taille; ++i)
    {
      T[i] = i;
    }
    break;

  case 'i':
    //Tableau Rangé Inversé
    for (long i = 0; i < taille; ++i)
    {
      T[i] = taille - i;
    }
    break;

  case 'c':
    //Tableau Constant
    for (long i = 0; i < taille; ++i)
    {
      T[i] = 0;
    }
    break;

  default:
    break;
  }
}
